unit vQuadrat;

{oben='o'
 obenRechts='p'
 rechts='r'
 rechtsUnten='s'
 unten='u'
 untenLinks='v'
 links='l'
 linksOben='m'}

INTERFACE

uses
  MStiftUndCo,crt;
const
  AktFarbe=rot;
  verzoegerung=0;
type
  vQuad=^Quadrat;
  quadrat=object
    xPos, yPos, groesse, nummer: word;
    dns: string;
    stift: vBuntStift;
    lPartner,rPartner: vQuad;
    originalFarbe:word;
    constructor init(nDNS:string; nNummer,nGroesse,nXpos,nYpos: word; richtung: char; nfarbe:byte);
    destructor ende(richtung:char);
    procedure zeichne;
    procedure bewege(wohin,richtung:char);
    procedure aktiviere;
    procedure deaktiviere;
    function wurdeGetroffen(x,y:word; richtung:char):boolean;
    procedure spiegle;
    procedure drehe;
    procedure zeichneAlle(modus:byte; nXpos,nYpos:word; richtung:char);
    procedure neuDNS(nDNS:string;richtung:char);
  end;

IMPLEMENTATION

function pXpos(buchstabe:char;xpos,groesse: word): word;
begin
  case buchstabe of
   'l','m','v': pXpos:=(xpos-groesse);
   'r','p','s': pXpos:=(xpos+groesse);
  else pXpos:=xpos;
  end;
end;

function pYpos(buchstabe:char; ypos,groesse: word): word;
begin
  case buchstabe of
   'o','p','m': pYpos:=(ypos-groesse);
   'u','v','s': pYpos:=(ypos+groesse);
  else pYpos:=ypos;
  end;
end;

function gegen(buchstabe: char): char;
begin
  case buchstabe of
    'o': gegen:='u';
    'u': gegen:='o';
    'l': gegen:='r';
    'r': gegen:='l';
    'p': gegen:='v';
    's': gegen:='m';
    'v': gegen:='p';
    'm': gegen:='s';
  end;
end;

procedure quadrat.zeichneAlle(modus:byte; nXpos,nYpos:word; richtung:char);
begin
  xpos:=nXpos;
  ypos:=nYpos;
  if (((richtung='l')or(richtung='b'))and(nummer>1)) then
    lPartner^.zeichneAlle(modus,pXpos(gegen(dns[nummer-1]),xpos,groesse),
                                pYpos(gegen(dns[nummer-1]),ypos,groesse),'l');
  if (((richtung='r')or(richtung='b'))and(nummer<=length(dns))) then
    rPartner^.zeichneAlle(modus,pXpos(dns[nummer],xpos,groesse),
                                pYpos(dns[nummer],ypos,groesse),'r');
  case modus of
    1: stift^.normal;
    2: stift^.radiere;
    3: stift^.wechsle;
  end;
  zeichne;
end;

procedure quadrat.neuDNS(nDNS:string;richtung:char);
begin
  if (((richtung='l')or(richtung='b'))and(nummer>1)) then lPartner^.neuDNS(nDNS,'l');
  if (((richtung='r')or(richtung='b'))and(nummer<=length(dns))) then rPartner^.neuDNS(nDNS,'r');
  dns:=nDNS;
end;

procedure quadrat.spiegle;
var
  i: byte;
  function spiegel(buchstabe:char):char;
  begin
    case buchstabe of
      'l': spiegel:='r';
      'r': spiegel:='l';
      'p': spiegel:='m';
      'm': spiegel:='p';
      'v': spiegel:='s';
      's': spiegel:='v';
      else spiegel:=buchstabe;
    end;
  end;
begin
  zeichneAlle(2,xpos,ypos,'b');
  for i:=1 to length(dns) do dns[i]:=spiegel(dns[i]);
  neuDNS(dns,'b');
  zeichneAlle(1,xpos,ypos,'b');
end;

procedure quadrat.drehe;
var
  i: byte;
  function dreh(buchstabe:char):char;
  begin
    case buchstabe of
      'r': dreh:='u';
      'l': dreh:='o';
      'o': dreh:='r';
      'u': dreh:='l';
      's': dreh:='v';
      'p': dreh:='s';
      'm': dreh:='p';
      'v': dreh:='m';
      else dreh:=buchstabe;
    end;
  end;
begin
  zeichneAlle(2,xpos,ypos,'b');
  for i:=1 to length(dns) do dns[i]:=dreh(dns[i]);
  neuDNS(dns,'b');
  zeichneAlle(1,xpos,ypos,'b');
end;

procedure quadrat.zeichne;
begin
  stift^.hoch;
  stift^.bewegeBis(xPos,yPos);
  stift^.runter;
  delay(verzoegerung);
  stift^.zeichneRechteck((Groesse-2),(Groesse-2));
end;

constructor quadrat.init(nDNS:string; nNummer,nGroesse,nXpos,nYpos: word; richtung: char; nfarbe:byte);
begin
  new(stift);
  stift^.init;
  dns:=nDNS;
  nummer:=nNummer;
  xpos:=nXpos;
  ypos:=nYpos;
  groesse:=nGroesse;
  stift^.normal;
  if nfarbe=0 then
    repeat
      originalFarbe:=(random(14)+2);
    until originalFarbe<>AktFarbe
  else originalFarbe:=nfarbe;
  stift^.SetzeFarbe(originalFarbe);
  zeichne;
  if (((richtung='r')or(richtung='b'))and(nummer<=length(dns))) then
    begin
      new(rPartner);
      rPartner^.init(dns,(nummer+1),groesse,pXpos(dns[nummer],xpos,groesse),
                     pYpos(dns[nummer],ypos,groesse),'r',originalFarbe);
    end;
  if (((richtung='l')or(richtung='b'))and(nummer>1)) then
    begin
      new(lPartner);
      lPartner^.init(dns,(nummer-1),groesse,pXpos(gegen(dns[nummer-1]),xpos,groesse),
                     pYpos(gegen(dns[nummer-1]),ypos,groesse),'l',originalFarbe);
    end;
end;

procedure quadrat.bewege(wohin,richtung:char);
begin
  stift^.radiere;
  zeichne;
  if (((richtung='l')or(richtung='b'))and(nummer>1)) then lPartner^.bewege(wohin,'l');
  if (((richtung='r')or(richtung='b'))and(nummer<=length(dns))) then rPartner^.bewege(wohin,'r');
  case wohin of
   'l': xpos:=(xpos-groesse);
   'r': xpos:=(xpos+groesse);
   'o': ypos:=(ypos-groesse);
   'u': ypos:=(ypos+groesse);
  end;
  stift^.normal;
  zeichne;
end;

function quadrat.wurdeGetroffen(x,y:word; richtung:char):boolean;
  function lGetroffen: boolean;
  begin
    if (((richtung='l')or(richtung='b'))and(nummer>1)) then
      if lPartner^.wurdeGetroffen(x,y,'l') then lGetroffen:=true
                                           else lGetroffen:=false
    else lGetroffen:=false;
  end;
  function rGetroffen: boolean;
  begin
    if (((richtung='r')or(richtung='b'))and(nummer<=length(dns))) then
      if rPartner^.wurdeGetroffen(x,y,'r') then rGetroffen:=true
                                           else rGetroffen:=false
    else rGetroffen:=false;
  end;
begin
  if ((x>xpos)and(x<(xpos+groesse))and(y>ypos)and(y<(ypos+groesse))) then
    wurdeGetroffen:=true
  else
    if not( lGetroffen or rGetroffen) then wurdeGetroffen:=false
                                      else wurdeGetroffen:=true;
end;

procedure quadrat.aktiviere;
begin
  zeichneAlle(1,xpos,ypos,'b');
  stift^.radiere;
  zeichne;
  stift^.normal;
  stift^.setzeFarbe(AktFarbe);
  zeichne;
end;

procedure quadrat.deaktiviere;
begin
  stift^.radiere;
  zeichne;
  stift^.normal;
  stift^.setzeFarbe(originalFarbe);
  zeichne;
end;

destructor quadrat.ende(richtung:char);
begin
  if (((richtung='l')or(richtung='b'))and(nummer>1)) then
  begin
    lPartner^.ende('l');
    dispose(lPartner);
  end;
  if (((richtung='r')or(richtung='b'))and(nummer<=length(dns))) then
  begin
    rPartner^.ende('r');
    dispose(rPartner);
  end;
  stift^.radiere;
  zeichne;
  stift^.gibfrei;
  dispose(stift);
end;

end.